#ifndef CERNfunctions_HXX
#define CERNfunctions_HXX

#include "Rtypes.h"

// First-order Differential Equations (Runge-Kutta) - MATHLIB D200 

extern void RKSTP(Int_t &N, Float_t &H, Float_t &X, Float_t *Y,
		  void (*SUB)(Float_t X, Float_t *Y, Float_t *F),
		  Float_t *W);

extern void RKSTP(Int_t &N, Double_t &H, Double_t &X, Double_t *Y,
		  void (*SUB)(Double_t X, Double_t *Y, Double_t *F),
		  Double_t *W);

// First-order Differential Equations (Gragg-Bulirsch-Stoer) - MATHLIB D201 

extern void DEQBS(Int_t &N, Float_t &X1, Float_t &X2, Float_t *Y,
		  Float_t &H0, Float_t &EPS,
		  void (*SUB)(Float_t X, Float_t *Y, Float_t *F),
		  Float_t *W);

extern void DEQBS(Int_t &N, Double_t &X1, Double_t &X2, Double_t *Y,
		  Double_t &H0, Double_t &EPS,
		  void (*SUB)(Double_t X, Double_t *Y, Double_t *F),
		  Double_t *W);

// First-order Differential Equations (Runge-Kutta-Merson) - MATHLIB D202 

extern void DEQMR(Int_t &N, Float_t &X1, Float_t &X2, Float_t *Y,
		  Float_t &H0, Float_t &EPS,
		  void (*SUB)(Float_t X, Float_t *Y, Float_t *F),
		  Float_t *W);

extern void DEQMR(Int_t &N, Double_t &X1, Double_t &X2, Double_t *Y,
		  Double_t &H0, Double_t &EPS,
		  void (*SUB)(Double_t X, Double_t *Y, Double_t *F),
		  Double_t *W);

#endif /* CERNfunctions_HXX */

/* end of file CERNfunctions.hxx */
