/* Main header for the -*- C++ -*- GSL complex number classes.
   (Based on the GNU ANSI C++ Library. Modified by Jacek M. Holeczek, 05.2001.)
   Copyright (C) 1994 Free Software Foundation */

#ifndef __GSL_complex_HXX__
#define __GSL_complex_HXX__

namespace gsl {

#include "gsl/gsl_complex.h"
#include "gsl/gsl_complex_math.h"

  extern "C++" {

    /* GSL complex classes */
    class fcomplex;
    class dcomplex;
    class ldcomplex;

    /* GSL complex typedefs */
    typedef fcomplex float_complex;
    typedef dcomplex double_complex;
    typedef ldcomplex long_double_complex;

  } /* extern "C++" */

} /* namespace gsl */

#include "fcomplex.hxx"
#include "dcomplex.hxx"
#include "ldcomplex.hxx"

#endif /* ifndef __GSL_complex_HXX__ */

/* End of file complex.hxx */
