// -*- mode: c++ -*- 
//
// $Id$
//
#ifndef Classes_H
#define Classes_H
#include <TObject.h>
#include <TBuffer.h>
#include <TClonesArray.h>
// FIXME: Hack to allow nested classes. We define ClassDef2 here. 
#include "hack.h"

class Top : public TObject 
{
 private:
  int          fN;

  TClonesArray fArray;
 public:
  class Nested : public TObject 
  {
  private:
    int fNested;
  public:   
    Nested(int nested=0) : fNested(nested) {}
    int  GetNested() const { return fNested; }
    void SetNested(int nested) { fNested = nested; }

    ClassDef2(Nested, 1)  // Nested class
  };

  Top() : fN(0), fArray("Top::Nested",0) {}
  int     GetN() const { return fN; }
  void    AddNested(int nested) { new(fArray[fN++]) Nested(nested); }
  Nested* GetNested(int idx)    { 
    return (idx >= fArray.GetEntries() || idx < 0) ? 0 :
      (Nested*)fArray[idx]; }

  ClassDef(Top, 1)  // Top class
};

#ifdef __CINT__
// FIXME: Hack so that CINT nows about this operator
R__extern TBuffer &operator>>(TBuffer &buf, Top::Nested *&obj);
#endif
#endif


  
    
