#ifndef FOO_HH
#define FOO_HH 

#include <TClonesArray.h>

class FooData : public TObject {
private:
  Float_t fData;
public:
  FooData(void);
  FooData(Float_t data);

  Float_t GetData(void) const { return fData; }
  void    SetData(Float_t data) { fData = data; }

  ClassDef(FooData,1) // 
};

class FooTable : public TObject { 
private:
  TClonesArray* fArray;
  Char_t        fName[16];
  Int_t         fUser;
  Int_t         fIndex;
public:
  FooTable(void);
  FooTable(const Char_t* name, Int_t user);

  void     Add(Float_t x) { new((*fArray)[fIndex++]) FooData(x); }
  FooData* At(Int_t i) { return (FooData*)fArray->At(i); }
  void     SetUser(Int_t user) { fUser = user; }
  Int_t    GetUser(void) const { return fUser; }
  Char_t*  GetName(void) const { return fName; }

  ClassDef(FooTable,1) // 
};

#endif 

