#include <iostream>
#include <TROOT.h>
#include <TFile.h>
#include <TTree.h>
#include "Foo.hh"

TROOT fooRoot("FooRoot", "FooRoot");

int 
main(int argc, char** argv) 
{
  
  cout << "Opening file \"File.root\"" << endl;
  TFile* file      = new TFile("File.root", "RECREATE");

  cout << "Creating tables \"Table1\", \"Table2\"" << endl;
  // Change the names to end in '.' to be able to Scan/Draw/Query each
  // individual sub-branch. 
  FooTable* table1 = new FooTable("Table1", 10);
  FooTable* table2 = new FooTable("Table2", 20);

  cout << "Creating tree and branches" << endl;
  TTree* tree      = new TTree("Tree", "A Foo Tree");
  TBranch* branch1 = tree->Branch(table1->GetName(), "FooTable", &table1);
  TBranch* branch2 = tree->Branch(table2->GetName(), "FooTable", &table2);

  cout << "Filling tables with FooData objects" << endl;
  for (Int_t i = 0; i < 10; i++) {
    table1->Add((Float_t)i / 10 + i); 
    table2->Add(i * 10 + i);
  }

  cout << "Filling tree" << endl;
  tree->Fill();
  tree->Print(); 

  cout << "Writting to disk" << endl;
  tree->Write();
  file->Close();

  return 0;
}

