// -*- mode: c++ -*- 
//
// Author:    Christian Holm <cholm@nbi.dk>
// Date:      Thu May 11 22:06:15 2000
// Copyrigth: 2000 Brahms Collaboration 

#ifndef ROOT_TAppOptionManager 
#define ROOT_TAppOptionManager

class TString;
class TObject;
class TObjArray;
class THashTable;
class THashList;
class TAppOption;

class TAppOptionManager : public TObject 
{
private:
  // TObjArray*       fTable;
  THashList*       fTable;
  Int_t            fMajorVersion;       
  Int_t            fMinorVersion;       
  TString*         fProgName;
  TString*         fHelpString;
  TString*         fVersionString;
  TAppBoolOption* fHelpOption;
  TAppBoolOption* fVersionOption;

  void             SetOptionValue(Char_t  option, Char_t* value);
  void             SetOptionValue(Char_t* option, Char_t* value);
  Bool_t           ProcessLongOption(Char_t* argument);
  Bool_t           ProcessShortOption(Char_t option, Char_t* value=0);
public:
  TAppOptionManager(Int_t major=0, 
		     Int_t minor=1,
		     const Char_t* versionString=0,
		     const Char_t* helpString=0);
  void    AddOption(TAppOption* option);
  void    ProcessCommandLine(Int_t& argc, Char_t** argv);
  Bool_t  ShowHelp(void);
  Bool_t  ShowVersion(void);
  TAppOption*     GetOption(Char_t  option);
  TAppOption*     GetOption(Char_t* option);
    
  ClassDef(TAppOptionManager,0) // Option mananger class 
}
;

#endif

