ObjSuf        = obj
SrcSuf        = cpp
ExeSuf        = .exe
DllSuf        = dll
OutPutOpt     = /out:
RM            = del/q

# Win32 system with Microsoft Visual C/C++
APPVER = 4.0
TARGETOS = BOTH
!include <win32.mak>
CC            = $(cc)
CXX           = $(cc)

CXXFLAGS      = $(cvarsdll) /Zi /Fd$(PDB) /G5 /MD -D_WINDOWS -I$(ROOTSYS)/include
LD            = $(link)
LDFLAGS       = $(conlflags)
SOFLAGS       = /NODEFAULTLIB /INCREMENTAL:NO /NOLOGO /DLL /PDB:$(PDB)_all 
ROOTLIBS      = $(ROOTSYS)/lib/*.lib
LIBS          = $(ROOTLIBS) $(guilibsdll) MSVCIRT.LIB
LIBSALL       = $(ROOTLIBS)

HDRS     =  TStint.h TSArrayI.h T3DFit.h TPhys.h TLitGlob.h TComplex.h TPol3.h TPol4.h TMessErr.h T33Matrix.h \
  T33CMatrix.h TSellmeier.h T3CVector.h TEqIndex.h TPolynom.h TMeas.h TFitMeas.h \
  TFamilyOfFits.h TOpticMaterial.h TSParticle.h TRevetment.h \
  ThinSlice.h T3Vector.h TFace.h TSupplShape.h TSBRIK.h TSTRD1.h \
  TSTRD2.h TSPARA.h TSTRAP.h TS8PTS.h TSCYL.h TSTUBE.h TSCONE.h \
  TSNode.h TOtherSide.h TContact.h  TPhotonCradle.h TSpontan.h TTWave.h TPhoton.h \
  TResults.h  TPublication.h TDetector.h TStatSurfD.h TStatVolD.h TStatAPD.h \
  TBeam.h
SRCS     = main.cpp TStint.cpp TSArrayI.cpp T3DFit.cpp TPhys.cpp TLitGlob.cpp TComplex.cpp TPol3.cpp TPol4.cpp TMessErr.cpp \
  TSellmeier.cpp T33Matrix.cpp T33CMatrix.cpp T3CVector.cpp TEqIndex.cpp TPolynom.cpp \
  TMeas.cpp TFitMeas.cpp TFamilyOfFits.cpp TOpticMaterial.cpp TSParticle.cpp TRevetment.cpp \
  ThinSlice.cpp T3Vector.cpp TFace.cpp TSupplShape.cpp TSBRIK.cpp TSTRD1.cpp \
  TSTRD2.cpp TSPARA.cpp TSTRAP.cpp TS8PTS.cpp TSCYL.cpp TSTUBE.cpp TSCONE.cpp \
  TSNode.cpp TOtherSide.cpp TContact.cpp TPhotonCradle.cpp  TSpontan.cpp TTWave.cpp TPhoton.cpp \
  TResults.cpp TPublication.cpp TDetector.cpp TStatSurfD.cpp TStatVolD.cpp TStatAPD.cpp \
   TBeam.cpp litranidict.cpp
OBJS     = main.obj TStint.obj TSArrayI.obj T3DFit.obj TPhys.obj TLitGlob.obj TComplex.obj TPol3.obj TPol4.obj TMessErr.obj \
  TSellmeier.obj T33Matrix.obj T33CMatrix.obj T3CVector.obj TEqIndex.obj TPolynom.obj \
  TMeas.obj TFitMeas.obj TFamilyOfFits.obj TOpticMaterial.obj TSParticle.obj TRevetment.obj \
  ThinSlice.obj T3Vector.obj TFace.obj TSupplShape.obj TSBRIK.obj TSTRD1.obj \
  TSTRD2.obj TSPARA.obj TSTRAP.obj TS8PTS.obj TSCYL.obj TSTUBE.obj TSCONE.obj \
  TSNode.obj TOtherSide.obj TContact.obj TPhotonCradle.obj TSpontan.obj TTWave.obj TPhoton.obj \
  TResults.obj TPublication.obj TDetector.obj TStatSurfD.obj TStatVolD.obj TStatAPD.obj \
  TBeam.obj litranidict.obj
PROGRAM  = litrani$(ExeSuf)
all:        $(PROGRAM)
$(PROGRAM): $(OBJS)
	@echo "Linking $(PROGRAM) ..."
	$(LD) $(LDFLAGS) $(OBJS) $(LIBS) $(OutPutOpt)$(PROGRAM)
	@echo "litrani.exe done"
clean:
	@$(RM) $(OBJS) litranidict*  litrani
###
TStint.obj: TStint.h
TSArrayI.obj: TSArrayI.h
T3DFit.obj: T3DFit.h
TPhys.obj: TPhys.h
TComplex.obj: TComplex.h
TPol3.obj: TPol3.h
TPol4.obj: TComplex.h TPol4.h
TMessErr.obj: TComplex.h T3Vector.h TLitGlob.h TMessErr.h
TSellmeier.obj: TMessErr.h TSellmeier.h
T33Matrix.obj:TMessErr.h T33Matrix.h
T33CMatrix.obj: TComplex.h TMessErr.h T33Matrix.h T33CMatrix.h
T3CVector.obj: TComplex.h TMessErr.h T33CMatrix.h T3Vector.h T3CVector.h
TPolynom.obj: TMessErr.h TPolynom.h
TMeas.obj: TMessErr.h TMeas.h
TLitGlob.obj: TLitGlob.h TMessErr.h TPhys.h TFitMeas.h \
  TFamilyOfFits.h TOpticMaterial.h TRevetment.h ThinSlice.h \
  TSupplShape.h TContact.h TDetector.h TResults.h TPublication.h \
  TSParticle.h TBeam.h TSpontan.h
TEqIndex.obj: TComplex.h TPol4.h TMessErr.h TLitGlob.h TEqIndex.h
TFitMeas.obj: TMessErr.h TLitGlob.h TPolynom.h TMeas.h TFitMeas.h
TFamilyOfFits.obj:  TFitMeas.h TLitGlob.h TFamilyOfFits.h
TOpticMaterial.obj: TMessErr.h TPhys.h TFitMeas.h TFamilyOfFits.h \
   TSellmeier.h TLitGlob.h TOpticMaterial.h
TSParticle.obj: TPhys.h TOpticMaterial.h TSParticle.h
TRevetment.obj: TComplex.h TMessErr.h TOpticMaterial.h TFitMeas.h \
  TFamilyOfFits.h TLitGlob.h TRevetment.h
ThinSlice.obj: TMessErr.h TFitMeas.h ThinSlice.h TLitGlob.h
T3Vector.obj: TMessErr.h T33Matrix.h T3Vector.h
TMessErr.obj: TComplex.h T3Vector.h TMessErr.h
TFace.obj: TMessErr.h T3Vector.h T33Matrix.h TRevetment.h TLitGlob.h \
  TOtherSide.h TContact.h TSupplShape.h TFace.h
TSupplShape.obj: T33CMatrix.h T33Matrix.h T3Vector.h TLitGlob.h \
  TMessErr.h TFace.h TPhys.h TOpticMaterial.h TRevetment.h TDetector.h \
  TSupplShape.h
TDetector.obj: TMessErr.h TFace.h TLitGlob.h T3Vector.h TDetector.h
TStatSurfD.obj: TPhys.h TOpticMaterial.h TStatSurfD.h
TStatVolD.obj:  TPhys.h TOpticMaterial.h TStatVolD.h
TStatAPD.obj: TPhys.h TOpticMaterial.h TSupplShape.h TStatAPD.h
TSBRIK.obj: TFace.h TSupplShape.h TSBRIK.h
TSTRD1.obj: TFace.h TSupplShape.h TSTRD1.h
TSTRD2.obj: TFace.h TSupplShape.h TSTRD2.h
TSPARA.obj: T3Vector.h TMessErr.h TFace.h TSupplShape.h TSPARA.h
TSTRAP.obj: TFace.h TSupplShape.h TSTRAP.h
TS8PTS.obj: TMessErr.h TFace.h TSupplShape.h TS8PTS.h
TSCYL.obj:  TFace.h TSupplShape.h TSCYL.h
TSTUBE.obj: TFace.h TSupplShape.h TSTUBE.h
TSCONE.obj: TMessErr.h TFace.h TSupplShape.h TSCONE.h
TSNode.obj: T3Vector.h TMessErr.h TLitGlob.h TSupplShape.h TSNode.h
TOtherSide.obj: TFace.h TOtherSide.h
TContact.obj: TMessErr.h TOtherSide.h TFace.h TSupplShape.h TLitGlob.h ThinSlice.h \
              TContact.h
TPhotonCradle.obj: TFitMeas.h TMessErr.h TLitGlob.h TOpticMaterial.h TSupplShape.h \
                   TFace.h TSNode.h TPhotonCradle.h
TSpontan.obj: TMessErr.h TSupplShape.h TPhoton.h TEqIndex.h \
              TLitGlob.h T3Vector.h TSNode.h \
              TPhys.h TOpticMaterial.h TResults.h TPublication.h TPhotonCradle.h \
			  TSpontan.h
TTWave.obj: TComplex.h T3Vector.h TMessErr.h TTWave.h
TPhoton.obj: TComplex.h TMessErr.h T3Vector.h TFace.h TPhys.h  TLitGlob.h \
             TOpticMaterial.h TRevetment.h ThinSlice.h TSupplShape.h \
			 TContact.h TStatSurfD.h TStatVolD.h TStatAPD.h \
			 TResults.h TTWave.h TEqIndex.h T33Matrix.h T33CMatrix.h \
			 T3CVector.h TPhoton.h
TResults.obj: TLitGlob.h TOpticMaterial.h TPhys.h TDetector.h \
              TStatSurfD.h TStatVolD.h TStatAPD.h TSupplShape.h \
			  TFace.h TResults.h
TPublication.obj: TLitGlob.h TResults.h TStatSurfD.h TStatVolD.h \
                  TStatAPD.h TMessErr.h TPublication.h
TBeam.obj: TFitMeas.h TLitGlob.h T3Vector.h TPhys.h TMessErr.h TOpticMaterial.h \
           TSupplShape.h TSNode.h TResults.h TPublication.h TEqIndex.h TPhoton.h \
		   TSParticle.h TBeam.h

litranidict.cpp: $(HDRS)
	@echo "Deleting dictionary..."
	@$(RM) litranidict.h litranidict.cpp litranidict.obj
	@echo "Generating dictionary ..."
	@$(ROOTSYS)\bin\rootcint litranidict.cpp -c $(HDRS) LinkDef.h

.$(SrcSuf).$(ObjSuf):
        $(CXX) $(CXXFLAGS) -c $<

