<HTML>
<BODY bgcolor=#ffeeee TEXT="#000000" VLINK="#00af00" LINK="#005f00" ALINK="ff0000">
<HEAD>
<TITLE>The root primer page</TITLE>
<!-- Changed by: Soeren Lange, 27-Jul-1998 -->
</HEAD>
<H2>The ROOT Primer Page</H2>
<P>
A Beginners Guide to the 
<A HREF="http://root.cern.ch">ROOT</A> Data Analysis System<BR>
<P>
<I>Last Update Mon Jul 27 09:17:08 CEST 1998</I>  
<P>

<HR>

<P>

ROOT has the following characteristics:

<UL>
<LI> Many ROOT concepts (e.g. data structures) have their origin in
<A HREF="http://wwwcn1.cern.ch/asd/paw/index.html">PAW</A>,
the worldwide spread physics data analysis package.
PAW is part of the 
<A HREF="http://wwwcn1.cern.ch/asd/index.html">CERNLIB</A>
from <A HREF="http://www.cern.ch">CERN</A> High Energy Physics Laboratory.

The striking differences to PAW (when using root in a simple interactive 
session):

<UL>
<LI>All graphical objects (e.g. 3D data plot) can be rotated
with a mouse.
<LI>All text objects (e.g. axis titles, statistics boxes) 
can be moved as well as changed (size, font, color) with a mouse 
or pull down menus.
<LI>3D Histograms (!)
</UL>

As a comparison, the 
<A HREF="http://www.fnal.gov/fermitools/">FERMILAB Software Tools</A>,
e.g. 
<A HREF="http://www.fnal.gov/fermitools/abstracts/histoscope.html">
Histo-Scope / NPlot</A> provide very good 3D and mouse functionality as well,
but only a very limited user interface (e.g. no fit procedures).

<LI> ROOT is based upon C++ (PAW was based upon FORTRAN).
More C++ Information:
<A HREF="http://info.desy.de/user/projects/C++.html">
C++ Virtual Library</A>,
<A HREF="http://www.icce.rug.nl/docs/cplusplus/cplusplus.html/C++">
C++ Annotations</A>
<LI>To my knowlegde, ROOT was at first presented to a larger auditory
on the 
<A HREF="http://lapphp0.in2p3.fr/aihep/aihep96/aihep96.html">AIHEP96</A>
conference. A 
<A HREF="http://lapphp0.in2p3.fr/aihep/aihep96/abstracts/a_se/p_se.html#IA">
summary talk</A> was given by Rene Brun.
<LI>Current actual version is Vers. 0.90/12 , 13/01/97
<LI>Download from <A HREF="http://root.cern.ch/root/Availability.html#download">here</A><BR>
<I>The original AIX 3.2.5 Distribution Package was linked by us and can also
be obtained from 
<A HREF="http://pktw09.phy.tu-dresden.de/root_v0.9.AIX.3.2.5.tar.gz">
here</I></A>
<LI>PostScript and HTML Documentation from <A HREF="http://root.cern.ch/root/Availability.html#documentation">here</A>
</UL>

<HR>

<H4>The ROOT mailing list: <I>roottalk</I></H4>

(Instructions taken from an email of 
<I>Fons.Rademakers@cern.ch</I>, 15/01/96)

<UL>
<LI>For a question or a bug report send an email to 
<I>roottalk@root.cern.ch</I>
<LI>To become a member of roottalk send an email to
<I>Majordomo@root.cern.ch</I> 
with the following
command in the body of your email message:
<P>

<PRE>
    subscribe roottalk mail@address
</PRE>

<P>
<LI>If you ever need to get in contact with the owner of the list,
send email to <I>owner-roottalk@root.cern.ch</I> .

<P>
<LI> 
<A HREF="http://root.cern.ch/root/roottalk/">roottalk archive</A> 
(all roottalk emails since beginning, ordered by [date][subject][author])
</UL>

<HR>

<H3><BLINK>Quick start for PAW users:</BLINK><BR></H3>
<A HREF="paw2root.html">PAW2ROOT</A>
syntax conversion table<BR>
An updated version by David d'Enterria is
<A HREF="http://ganp03.in2p3.fr/nof/paw2root.shtml"><I>here</I></A>
<P>


<HR>

<center>
<H2>The Primer</H2>
</center>

<B>Part A:</B> General Remarks<BR>
<B>Part B:</B> List of objects<BR>
<A HREF="#canvas">Canvas</A> |
<A HREF="#fit">Fit</A> |
<A HREF="#function">Function</A> |
<A HREF="#graph">Graph</A> |
<A HREF="#histo">Histogram</A> |
<A HREF="#ntuple">Ntuple</A> |
<A HREF="#ps">Postscript</A><BR>
<B><A HREF="#partC">Part C:</A></B>Adding own classes to root <I>(to be added soon)</I>
<P>

<HR>

<H3><I>Part A:</I>General Remarks</H3>

<UL>
<LI>All the examples can be executed within <B>root</B> by typing
<PRE>
root [0] .x filename.C;
</PRE>
<LI>You can look what objects (ntuples, histograms, ...) are defined
in your <B>root</B> session by typing<BR>
<PRE>
root [0] .ls
</PRE>
<LI>You can start <B>root</B> in the <B>root++</B> mode by typing<BR>
<PRE>
root [0] TBrowser *b = new TBrowser
</PRE>
</UL>

<HR>

<H3><I>Part B:</I>List of ROOT Objects</H3>

<!-------------------------------------------------------------------->

<HR>
<A NAME="canvas"></A>
<H4>Canvas</H4>

<I>Graphical object.</I>

<UL>
<LI>A <b>canvas</b> can simply be understood as a graphical window 
(corresponding to a HIGZ window in PAW). 
If you have not created any canvas, the default
canvas <I>c1</I> is created automatically when plotting something.

<LI>Inside your canvas you have to define <b>pads</b> corresponding 
to zones in your PAW session.

<LI>Inside a pad you can put <b>objects</b>,
i.e. write text, draw lines,
plot functions, histograms, ntuples and so on.

<LI>When putting your mouse pointer onto the objects,
you can move them (<I>symbol:</I> 4 arrows), scale them (<I>symbol:</I> hand)
or rotate them (<I>symbol:</I> 2 bended arrows).

<LI>If you have 2 pads within a canvas, you have to use 

<PRE>
padname.cd();
</PRE>

to change your active pad.

<LI>Within one pad, you can define as many (sub-)pads as you like
and jump between them using the <PRE>subpadname.cd()</PRE> command as well.

<P>
Example: <A HREF="canvas.C">canvas.C</A>
<P>
</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="fit"></A>
<H4>Fit</H4>

<UL> 
<LI>Fitting of a histogram or a graph is possible<BR>

<PRE>
hx->Fit("gaus");    // fit histogram

graph->Fit("pol5"); // fit graph
</PRE>

Predefined fit functions: <I>gaus, expo, pol<B>n</B> (n=1,2,3,...)</I>

<P>

<LI>Fitting with user defined fit functions<BR>
<I>taken from a roottalk email from R. Brun, 7/03/97</I><BR>

For example, if you want to create a function to be fitted with
two parameters involving sin(x):<BR>

<PRE>
TF1 *f1 = new TF1("f1","[0]*sin([1]*x)",0,3.14);
f1->SetParameter(0,1.1);  //initialize first parameter to 1.1
f1->SetParameter(1,0.2);

graph->Fit("f1");
</PRE>

<P>

<LI>Fit Range (taken from <A HREF="http://root.cern.ch/root/html/TH1.html#TH1:Fit">here</A>)<BR>
<I>
In order to use the Range option, one must first create a function
with the expression to be fitted. For example, if your histogram
has a defined range between -4 and 4 and you want to fit a gaussian
only in the interval 1 to 3, you can do:<BR>
</I>
<PRE>
TF1 *f1 = new TF1("f1","gaus",1,3);
histo->Fit("f1","R");
</PRE>
</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="function"></A>
<H4>Function</H4>

<I>Mathematical object.</I>

<UL>
<LI> If you want to plot a 1-dimensional function, just type

<PRE>
   fun1 = new TF1("fun1","sin(x)",0,10);
   fun1->Draw();
</PRE>

<LI> If you want to plot a 2-dimensional function, just type

<PRE>
   fun2 = new TF2("fun2","sin(x)*sin(y)",-10.0,10.0,-10.0,10.0);
   fun2->Draw("surf4");
</PRE>

You can rotate the 3D plot by use of the mouse.
</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="graph"></A>
<H4>Graph</H4>

<I>x-y plot with or without error bars</I>

<UL>

<LI>root [0] .x <A HREF="graph.C">graph.C</A>;<BR>

as a simple example (axis scaling automatically). You can change position
of the data points by use of the mouse (!).

<P>

<LI>root [0] .x <A HREF="graphbeauty.C">graphbeauty.C</A>;<BR>

makes the former example more beautiful (using canvas and graph options).

<P>

You can also set all the options by clicking with your mouse 
and choosing the
<I>SetLineAttributes, SetFillAttributes</I> or <I>SetMarkerAttributes</I>
panels (right mouse button).

<P>

<LI>
<table border>
<tr><td>Color Index<td>Color</tr>
<tr></tr>
<tr><td>1<td>black</tr>
<tr><td>2<td>red</tr>
<tr><td>3<td>green</tr>
<tr><td>4<td>blue</tr>
<tr><td>5<td>yellow</tr>
<tr><td>6<td>pink</tr>
<tr><td>7<td>light blue</tr>
<tr><td>8<td>white</tr>
</table>

</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="histo"></A>
<H4>Histogram</H4>

<I>A histogram is a data structure containing 1D, 2D or 3D channels.
The number of events is stored as a function of the channel index. 
</I>
<UL>

<LI>If you have already a filled Ntuple and want to project it into a
histogram <I>h1</I>, just type

<pre>
ntuple.Draw("x>>h1","","h1");
h1.Draw();
</pre>

without explicitely creating <I>h1</I>.
<P>

<LI>If you want to fill a 1D, 2D or 3D (!) histogram 
with some data stored in a variable <B>x</B> within your C-file,
here is an example <A HREF="histo.C">histo.C</A>
for random generated data.

<P>

<LI>Change of axis range<BR>

If you have the 2-Dim histogram <I>hxy</I> of the former example (range -4:4),
you can draw it into a given frame (which itself is simply a new, empty histogram).

<PRE>
TH2F frame("frame","2-Dim", 40, -3, 3, 40, -3, 3);
frame.Draw();
hxy.Draw("same");
</PRE>

<LI>Copy a histogram <I>h1</I>into a new one<BR>
<PRE>
TH1F h2 = new TH1F();
h1->Copy(h2); // from -> to

/* or simply */

TH1F h2 = h1;
</PRE>

</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="ntuple"></A>
<H4>NTuples</H4>

<I>
A NTuple is a matrice-like data structure with <B>n</B> rows 
(corresponding e.g. to the number of events) and <B>m</B> columns 
(corresponding e.g. to the number of parameters per event).
</I>

<P>

For example you may have a data file (ASCII) like 
<A HREF="xyz.dat">xyz.dat</A> 
and you want to <I>(a)</I> read it and <I>(b)</I> 
put it into a NTuple Structure. Do it like this:

<UL>
<LI>root [0] .x <A HREF="ntuplefix.C">ntuplefix.C</A>;<BR>
<P>
Simplest approach.
<P>
<LI>root [0] .x <A HREF="ntuplevar.C">ntuplevar.C</A>;<BR>
<P>
More comfortable approach. <BR>
Number of parameters and filename are given at runtime. <BR>
The data are addressed with a pointer *p.
This makes the filling of the ntuple very easy using <BR>
ntuple.Fill(p)
instead of using <BR>
ntuple.Fill(p[0],p[1],p[2],p[3],...)
<P>
<LI>Ntuple Plotting
<P>
<table border>
<tr><td>Plotting 1D<td>ntuple.Draw("x");</tr>
<tr><td>Plotting 2D<td>ntuple.Draw("y:x");</tr>
<tr><td>Plotting 3D<td>ntuple.Draw("z:y:x");</tr>
<tr><td>Plotting combinations of variables<td>ntuple.Draw("2*x-3*y");</tr>
<tr><td>Plotting data with a condition<td>ntuple.Draw("x","(x>0)");</tr>
<tr><td>Option: Plot into the same frame<td>ntuple.Draw("x"," ","same");<tr>
</table>

<P>

<LI>For disk resident ntuples (if storage exhausted in case of large ntuples)<BR>
you first have to open a root file
<PRE>
TFile myfile("myfile.root","NEW");
</PRE>
Each ntuple created afterwards is automatically disk resident.

</UL>
<P>

<!-------------------------------------------------------------------->

<HR>
<A NAME="ps"></A>
<H4>PostScript</H4>

<I>Graphical output into a printable file.</I>

<UL>
<LI>If you have already a canvas <I>c1</I> displaying a graph or a histogram, just type<BR>

<PRE>
TPostScript ps("graph.ps",-112);
c1->Draw();
ps.Close();
</PRE>

<LI>The different PS modes:

<table border>
<tr><td>-111<td>PS portrait<td></tr>
<tr><td>-112<td>PS landscape<td></tr>
<tr><td>-113<td>Encapsulated PS<td><I>not working in root v0.9</I></tr>
</table>

<P>

<P>

<LI>Change Size of the PS picture <I>(Bug in root v0.9)</I><BR>

<PRE>
ps.Range(4,4); // x- and y-range / cm
</PRE>

is <I>not</I> working. The picture always has the same size [ 20 cm x 8 cm ].<BR>
<I>Patch:</I> Edit <I>graph.ps</I>, search for ".25 .25 scale" and change
the x- and y-scaling factors according to your needs.

<P>

<LI>Special characters in Text:<BR>
"'a#" for the greek character \alpha, 
"\311" for the german letter &auml; etc. <BR>
For more information see
<A HREF="http://root.cern.ch/root/html/examples/psexam.C.html">here</A>
and overview tables 
<A HREF="http://root.cern.ch/root/html/ps/pstable1.ps">pstable1.ps</A> and
<A HREF="http://root.cern.ch/root/html/ps/pstable2.ps">pstable2.ps</A><BR>
<I>(located on the root WWW server)</I>.

<!-------------------------------------------------------------------->

</UL>

<!-------------------------------------------------------------------->

<HR>
<A NAME="partC"></A>
<H3><I>Part C:</I>Adding own classes to root</H3>

<UL>

<HR> 

<LI><B><I>Example 1: </I>Linking a small program</B><BR>
<I>containing simple root calls</I></BR>
<P>
You need 2 files:
<A HREF="Makefile.ex1">Makefile.ex1</A>,
<A HREF="histo-l.C">histo-l.C</A><BR>
<I>histo-l.C</I> is based upon <A HREF="histo.C">histo.C</A>
(see <A HREF="#histo">Histogram</A>).

<UL>

<LI>Edit Makefile.ex1
(choose compiler type and ROOTSYS path).

<LI>mv Makefile.ex1 Makefile
<P>
<LI><PRE>make histo-l</PRE>

<LI>You end up with the executable <I>histo-l</I>
which at runtime opens a rootfile and 
fills it with a 1-dim and a 2-dim histogram.
A 3-dim histogram (working in <I>histo.C</I>) is
not working, but I don't know why.

</UL>

<HR>

<LI><B><I>Example 2: </I>Linking your own <I>myroot</I></B><BR>
<I>containing new classes</I><BR>
<P>

At first you have to set some environment variables
<PRE>
   export ROOTSYS=...
   export PATH=$PATH:$ROOTSYS/bin
   export LIBPATH=$LIBPATH:$ROOTSYS/lib 
</PRE>
You need 4 files:
<A HREF="Makefile.ex2">Makefile.ex2</A>,
<A HREF="MyClass.h">MyClass.h</A>,
<A HREF="MyClass.C">MyClass.C</A>,
<A HREF="main.C">main.C</A><BR>

<P>

<UL>

<LI>Edit Makefile.ex2 (choose compiler type and ROOTSYS path)
<LI>mv Makefile.ex2 Makefile
<P>
<LI><PRE>make</PRE>
<LI>You end up with your own root executable <B>myroot</B> including <I>MyClass()</I>.<BR>
Now try to start it:

<PRE>
>> myroot
  *******************************************
  *                                         *
  *        W E L C O M E  to  R O O T       *
  *                                         *
  *   Version   0.90/12   15 January 1997   *
  *                                         *
  *  You are welcome to visit our Web site  *
  *          http://root.cern.ch            *
  *                                         *
  *******************************************
...
root [0] MyClass myclass
root [1] myclass.Print();
I = 0, F = 0
root [2] myclass.SetInt(1);
root [3] myclass.SetFloat(2.3);
root [4] myclass.Print();      
I = 1, F = 2.3
...
</PRE>

<LI><B>Dictionary:</B><BR>
You need to generate a <I>Dictionary</I> for your new classes.
This is done by calling <B>rootcint</B> (implemented in
the Makefile):

<PRE>
rootcint dict.C -c MyClass.h
</PRE>

<B>rootcint</B> reads <I>MyClass.h</I>
and generates
<I>dict.C</I> (and <I>dict.h</I> automatically)
to tell <B>root</B> about your new classes.
It is practical to put your class definitions 
into the <I>h</I>-files (and nothing else) to preserve
these files for use with <B>rootcint</B>.

</UL>

<HR>

<LI><B><I>Example 3: </I>Generating a shared library</B><BR>
<I>which can be loaded in a (standard) root session</I><BR>
<P>
You need 3 files:
<A HREF="MyClass.C">MyClass.C</A>,
<A HREF="MyClass.h">MyClass.h</A>,
<A HREF="genshlib">genshlib</A><BR>

<I>MyClass.C</I> and <I>MyClass.h</I> are identical to Example 2.<BR>

Try this:

<UL>

<LI> Edit genshlib (choose compiler type and ROOTSYS path)

<LI>Please read the remarks about a <B>Dictionary</B> in Example 2.
The same is valid for Example 3. The dictionary object file <I>dict.o</I>
must be part of the shared library.

<LI>Furthermore, you have to find out how to generate a shared lib on your system platform.
Using AIX, the command is

<PRE>
/usr/lpp/xlC/bin/makeC++SharedLib 
</PRE>

You find the right command in your <B>root</B> distribution in the file 
</I>$ROOTSYS/test/Makefile</I>:

<PRE>
$(EVENT):       $(EVENTO)
                ... (look here for the command)
</PRE>

<P>
<LI>Execute <PRE>genshlib</PRE>

<LI>You end up with a shared library <I>MyClass.so</I> which can be included 
dynamically in your <B>root</B> session. Try this:

<PRE>
>>root
  *******************************************
  *                                         *
  *        W E L C O M E  to  R O O T       *
  *                                         *
  *   Version   0.90/12   15 January 1997   *
  *                                         *
  *  You are welcome to visit our Web site  *
  *          http://root.cern.ch            *
  *                                         *
  *******************************************
...
root [0] gSystem->Load("MyClass.so");
root [1] MyClass myclass
root [2] myclass.Print();
I = 0, F = 0
...
</PRE>

</UL>

</UL>

<HR>

<I>Remark:</I>
Although we think that <B>root</B> is a brilliant concept,
this page claims to be <I>independent</B> from
the <B>root</B> development team.
Thus, hopefully objectivity is achieved.

<HR>

<A NAME="updtinfo"></A>
<H4><I>Update Information:</I></H4>

97/01/17 Page released at Technical University Dresden<BR>
97/02/12 Page added to "Applications using root" on http://root.cern.ch<BR>
97/07/03 Page moved to Tokyo Metropolitan University<BR>
97/07/03 Page moved to CERN<BR>
<P>

<HR>

<A HREF="mailto:Soeren.Lange@cern.ch">
Questions/Comments
</A> | 

<A HREF="http://www.ikf.physik.uni-frankfurt.de/~lange">
S&ouml;ren Lange</A>, <I>97/07/03</I>
